<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>m17n ライブラリ: シンボル</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body onload='searchBox.OnSelectItem(0);'>
<!-- 作成： Doxygen 1.6.3 -->
<script type="text/javascript"><!--
var searchBox = new SearchBox("searchBox", "search",false,'検索');
--></script>
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>メインページ</span></a></li>
      <li><a href="pages.html"><span>関連ページ</span></a></li>
      <li><a href="modules.html"><span>モジュール</span></a></li>
      <li><a href="annotated.html"><span>データ構造</span></a></li>
      <li><a href="files.html"><span>ファイル</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <img id="MSearchSelect" src="search/search.png"
             onmouseover="return searchBox.OnSearchSelectShow()"
             onmouseout="return searchBox.OnSearchSelectHide()"
             alt=""/>
        <input type="text" id="MSearchField" value="検索" accesskey="S"
             onfocus="searchBox.OnSearchFieldFocus(true)" 
             onblur="searchBox.OnSearchFieldFocus(false)" 
             onkeyup="searchBox.OnSearchFieldChange(event)"/>
        <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
        </div>
      </li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>シンボル<br/>
<small>
[<a class="el" href="group__m17nCore.html">コア API</a>]</small>
</h1>
<p>シンボルオブジェクトとそれに関する API.  
<a href="#_details">[詳細]</a></p>
<table border="0" cellpadding="0" cellspacing="0">
<tr><td colspan="2"><h2>型定義</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef struct MSymbolStruct *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">シンボルの型宣言.  <a href="#ga0f53a95817f0b5c26442f8e12f89c16d"></a><br/></td></tr>
<tr><td colspan="2"><h2>関数</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nSymbol.html#ga0f19d07c2dd83d37705ca628caaf8cd1">msymbol</a> (const char *name)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">シンボルを得る.  <a href="#ga0f19d07c2dd83d37705ca628caaf8cd1"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nSymbol.html#ga48e392412c68f18ce58ec0af642d0db5">msymbol_as_managing_key</a> (const char *name)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">管理キーを作る.  <a href="#ga48e392412c68f18ce58ec0af642d0db5"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nSymbol.html#gae590d761113d7bd7a687dbb39ac97c54">msymbol_is_managing_key</a> (<a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> symbol)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nSymbol.html#ga45a60105ebaeb9c0a9c36d84acd87553">msymbol_exist</a> (const char *name)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">指定された名前を持つシンボルを探す.  <a href="#ga45a60105ebaeb9c0a9c36d84acd87553"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">char *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nSymbol.html#ga551d4628363900cad49a908b598b821b">msymbol_name</a> (<a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> symbol)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">シンボルの名前を得る.  <a href="#ga551d4628363900cad49a908b598b821b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nSymbol.html#ga9b90027677f183f65d85dac0d7d5bb9c">msymbol_put</a> (<a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> symbol, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> key, void *val)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">シンボルプロパティに値を設定する.  <a href="#ga9b90027677f183f65d85dac0d7d5bb9c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nSymbol.html#ga62c1ccf5b0a9924061d3a596ae312527">msymbol_get</a> (<a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> symbol, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> key)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">シンボルプロパティの値を得る.  <a href="#ga62c1ccf5b0a9924061d3a596ae312527"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nSymbol.html#gaf0e0b5b8e6e0702ed87df88ad642d7f7">msymbol_put_func</a> (<a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> symbol, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> key, <a class="el" href="group__m17nCore.html#ga2216940cb054b8693aa9d65887bb4b5e">M17NFunc</a> func)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">シンボルプロパティの値(関数ポインタ)を設定する.  <a href="#gaf0e0b5b8e6e0702ed87df88ad642d7f7"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nCore.html#ga2216940cb054b8693aa9d65887bb4b5e">M17NFunc</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nSymbol.html#ga6446566f8f6a53e825cea16ffbf4c3bd">msymbol_get_func</a> (<a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> symbol, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> key)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">シンボルプロパティの値 (関数ポインタ) を得る.  <a href="#ga6446566f8f6a53e825cea16ffbf4c3bd"></a><br/></td></tr>
<tr><td colspan="2"><h2>変数</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nSymbol.html#ga0346fc05efcccc8f11271b51c0fe3eeb">Mnil</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">"nil" を名前として持つシンボル.  <a href="#ga0346fc05efcccc8f11271b51c0fe3eeb"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nSymbol.html#ga8769a573efbb023b4d77f9d03babc09f">Mt</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">"t" を名前として持つシンボル.  <a href="#ga8769a573efbb023b4d77f9d03babc09f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nSymbol.html#ga60daf7d600a1f487862366a37c171ce5">Mstring</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">"string" を名前として持つシンボル.  <a href="#ga60daf7d600a1f487862366a37c171ce5"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nSymbol.html#ga6592d4eb3c46fe7fb8993c252b8fedeb">Msymbol</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">"symbol" を名前として持つシンボル.  <a href="#ga6592d4eb3c46fe7fb8993c252b8fedeb"></a><br/></td></tr>
</table>
<hr/><a name="_details"></a><h2>説明</h2>
<p>シンボルオブジェクトとそれに関する API. </p>
<p>m17n ライブラリは一意に決まる識別子として <em>シンボル</em> と呼ぶオブジェクトを用いる。シンボルは X ライブラリのアトムと似ているが、 0 個以上の <em>シンボルプロパティ</em> を持つことができる。シンボルプロパティは <em>キー</em> と <em>値</em> からなる。キーはそれ自体シンボルであり、値は <code>(void *)</code> 型にキャストできるものなら何でもよい。「シンボル S が持つシンボルプロパティのうちキーが K のもの」を簡単に「S の K プロパティ」と呼ぶことがある。</p>
<p>シンボルの用途は主に以下の3通りである。</p>
<ul>
<li>シンボルプロパティおよび他のプロパティのキーを表す。</li>
</ul>
<ul>
<li>文字セット、コード系、フォントセットなどの各種オブジェクトを表す。</li>
</ul>
<ul>
<li>m17n ライブラリ関数の引数となり、関数の挙動を制御する。</li>
</ul>
<p><em>管理キー</em> と呼ばれる特別なシンボルがあり、管理キーをキーとして持つプロパティの値は <em>管理下オブジェクト</em> でなくてはならない。詳細は <a class="el" href="group__m17nObject.html">管理下オブジェクト</a> 参照。 </p>
<hr/><h2>型定義</h2>
<a class="anchor" id="ga0f53a95817f0b5c26442f8e12f89c16d"></a><!-- doxytag: member="m17n&#45;core.h::MSymbol" ref="ga0f53a95817f0b5c26442f8e12f89c16d" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef struct MSymbolStruct* <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>シンボルの型宣言. </p>
<p><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d" title="シンボルの型宣言.">MSymbol</a> は <em>シンボル</em> (symbol) オブジェクトの型である。 内部構造はアプリケーションプログラムからは見えない。 </p>

</div>
</div>
<hr/><h2>関数</h2>
<a class="anchor" id="ga0f19d07c2dd83d37705ca628caaf8cd1"></a><!-- doxytag: member="symbol.c::msymbol" ref="ga0f19d07c2dd83d37705ca628caaf8cd1" args="(const char *name)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> msymbol </td>
          <td>(</td>
          <td class="paramtype">const char *&nbsp;</td>
          <td class="paramname"> <em>name</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>シンボルを得る. </p>
<p>関数 <a class="el" href="group__m17nSymbol.html#ga0f19d07c2dd83d37705ca628caaf8cd1" title="シンボルを得る.">msymbol()</a> は <b>name</b> という名前を持つ正規化されたシンボルを返す。そのようなシンボルが存在しない場合には、生成する。生成されたシンボルは管理キーではない。</p>
<p>空白文字二つで始まるシンボルは m17n ライブラリ用であり、内部的にのみ用いられる。</p>
<dl class="user"><dt><b>戻り値:</b></dt><dd>この関数は見つけたか生成したかしたシンボルを返す。</dd></dl>
<dl class="user"><dt><b>エラー:</b></dt><dd>この関数は決して失敗しない。</dd></dl>
<dl class="user"><dt><b>参照:</b></dt><dd><a class="el" href="group__m17nSymbol.html#ga48e392412c68f18ce58ec0af642d0db5" title="管理キーを作る.">msymbol_as_managing_key()</a>, <a class="el" href="group__m17nSymbol.html#ga551d4628363900cad49a908b598b821b" title="シンボルの名前を得る.">msymbol_name()</a>, <a class="el" href="group__m17nSymbol.html#ga45a60105ebaeb9c0a9c36d84acd87553" title="指定された名前を持つシンボルを探す.">msymbol_exist()</a> </dd></dl>

</div>
</div>
<a class="anchor" id="ga48e392412c68f18ce58ec0af642d0db5"></a><!-- doxytag: member="symbol.c::msymbol_as_managing_key" ref="ga48e392412c68f18ce58ec0af642d0db5" args="(const char *name)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> msymbol_as_managing_key </td>
          <td>(</td>
          <td class="paramtype">const char *&nbsp;</td>
          <td class="paramname"> <em>name</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>管理キーを作る. </p>
<p>関数 <a class="el" href="group__m17nSymbol.html#ga48e392412c68f18ce58ec0af642d0db5" title="管理キーを作る.">msymbol_as_managing_key()</a> は名前 <b>name</b> を持つ新しく作られた管理キーを返す。すでに名前 <b>name</b> を持つシンボルがあれば、 <a class="el" href="group__m17nSymbol.html#ga0346fc05efcccc8f11271b51c0fe3eeb" title="&quot;nil&quot; を名前として持つシンボル.">Mnil</a> を返す。</p>
<p>空白文字二つで始まるシンボルは m17n ライブラリ用であり、内部的にのみ用いられる。</p>
<dl class="user"><dt><b>戻り値:</b></dt><dd>処理に成功すれば、この関数は生成したシンボルを返す。そうでなければ <a class="el" href="group__m17nSymbol.html#ga0346fc05efcccc8f11271b51c0fe3eeb" title="&quot;nil&quot; を名前として持つシンボル.">Mnil</a> を返す。</dd></dl>
<dl class="user"><dt><b>エラー:</b></dt><dd>MERROR_SYMBOL</dd></dl>
<dl class="user"><dt><b>参照:</b></dt><dd><a class="el" href="group__m17nSymbol.html#ga0f19d07c2dd83d37705ca628caaf8cd1" title="シンボルを得る.">msymbol()</a>, <a class="el" href="group__m17nSymbol.html#ga45a60105ebaeb9c0a9c36d84acd87553" title="指定された名前を持つシンボルを探す.">msymbol_exist()</a> </dd></dl>

</div>
</div>
<a class="anchor" id="gae590d761113d7bd7a687dbb39ac97c54"></a><!-- doxytag: member="symbol.c::msymbol_is_managing_key" ref="gae590d761113d7bd7a687dbb39ac97c54" args="(MSymbol symbol)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int msymbol_is_managing_key </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>symbol</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="ga45a60105ebaeb9c0a9c36d84acd87553"></a><!-- doxytag: member="symbol.c::msymbol_exist" ref="ga45a60105ebaeb9c0a9c36d84acd87553" args="(const char *name)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> msymbol_exist </td>
          <td>(</td>
          <td class="paramtype">const char *&nbsp;</td>
          <td class="paramname"> <em>name</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>指定された名前を持つシンボルを探す. </p>
<p>関数 <a class="el" href="group__m17nSymbol.html#ga45a60105ebaeb9c0a9c36d84acd87553" title="指定された名前を持つシンボルを探す.">msymbol_exist()</a> は <b>name</b> という名前を持つシンボルを探す。</p>
<dl class="user"><dt><b>戻り値:</b></dt><dd>もしそのようなシンボルが存在するならばそのシンボルを返す。そうでなければ、定義済みシンボル <a class="el" href="group__m17nSymbol.html#ga0346fc05efcccc8f11271b51c0fe3eeb" title="&quot;nil&quot; を名前として持つシンボル.">Mnil</a> を返す。</dd></dl>
<dl class="user"><dt><b>エラー:</b></dt><dd>この関数は決して失敗しない。 </dd></dl>
<dl class="user"><dt><b>参照:</b></dt><dd><a class="el" href="group__m17nSymbol.html#ga551d4628363900cad49a908b598b821b" title="シンボルの名前を得る.">msymbol_name()</a>, <a class="el" href="group__m17nSymbol.html#ga0f19d07c2dd83d37705ca628caaf8cd1" title="シンボルを得る.">msymbol()</a> </dd></dl>

</div>
</div>
<a class="anchor" id="ga551d4628363900cad49a908b598b821b"></a><!-- doxytag: member="symbol.c::msymbol_name" ref="ga551d4628363900cad49a908b598b821b" args="(MSymbol symbol)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">char* msymbol_name </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>symbol</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>シンボルの名前を得る. </p>
<p>関数 <a class="el" href="group__m17nSymbol.html#ga551d4628363900cad49a908b598b821b" title="シンボルの名前を得る.">msymbol_name()</a> は指定されたシンボル <b>symbol</b> の名前を含む文字列へのポインタを返す。</p>
<dl class="user"><dt><b>エラー:</b></dt><dd>この関数は決して失敗しない。 </dd></dl>
<dl class="user"><dt><b>参照:</b></dt><dd><a class="el" href="group__m17nSymbol.html#ga0f19d07c2dd83d37705ca628caaf8cd1" title="シンボルを得る.">msymbol()</a>, <a class="el" href="group__m17nSymbol.html#ga45a60105ebaeb9c0a9c36d84acd87553" title="指定された名前を持つシンボルを探す.">msymbol_exist()</a> </dd></dl>

</div>
</div>
<a class="anchor" id="ga9b90027677f183f65d85dac0d7d5bb9c"></a><!-- doxytag: member="symbol.c::msymbol_put" ref="ga9b90027677f183f65d85dac0d7d5bb9c" args="(MSymbol symbol, MSymbol key, void *val)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int msymbol_put </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>symbol</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>val</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>シンボルプロパティに値を設定する. </p>
<p>関数 <a class="el" href="group__m17nSymbol.html#ga9b90027677f183f65d85dac0d7d5bb9c" title="シンボルプロパティに値を設定する.">msymbol_put()</a> は、シンボル <b>symbol</b> 中でキーが <b>key</b> であるシンボルプロパティの値を <b>val</b> に設定する。そのシンボルプロパティにすでに値があれば上書きする。 <b>symbol</b>, <b>key</b> とも <a class="el" href="group__m17nSymbol.html#ga0346fc05efcccc8f11271b51c0fe3eeb" title="&quot;nil&quot; を名前として持つシンボル.">Mnil</a> であってはならない。</p>
<p><b>key</b> が管理キーならば、<b>val</b> は管理下オブジェクトでなくてはならない。この場合、古い値の参照数は <code>NULL</code> でなければ 1 減らされ、<b>val</b> の参照数は 1 増やされる。</p>
<dl class="user"><dt><b>戻り値:</b></dt><dd>処理が成功すれば、msymbol_put() は 0 を返す。そうでなければ -1 を返し、外部変数 <a class="el" href="group__m17nError.html#ga995a2e373cfd6a8e5eaca8686b5b0a73" title="m17n ライブラリのエラーコードを保持する外部変数.">merror_code</a> にエラーコードを設定する。</dd></dl>
<dl class="user"><dt><b>エラー:</b></dt><dd><code>MERROR_SYMBOL</code> </dd></dl>
<dl class="user"><dt><b>参照:</b></dt><dd><a class="el" href="group__m17nSymbol.html#ga62c1ccf5b0a9924061d3a596ae312527" title="シンボルプロパティの値を得る.">msymbol_get()</a> </dd></dl>

</div>
</div>
<a class="anchor" id="ga62c1ccf5b0a9924061d3a596ae312527"></a><!-- doxytag: member="symbol.c::msymbol_get" ref="ga62c1ccf5b0a9924061d3a596ae312527" args="(MSymbol symbol, MSymbol key)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void* msymbol_get </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>symbol</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>key</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>シンボルプロパティの値を得る. </p>
<p>関数 <a class="el" href="group__m17nSymbol.html#ga62c1ccf5b0a9924061d3a596ae312527" title="シンボルプロパティの値を得る.">msymbol_get()</a> は、シンボル <b>symbol</b> が持つシンボルプロパティのうち、キーが <b>key</b> であるものを探す。もし該当するシンボルプロパティが存在すれば、それの値を返す。そうでなければ <code>NULL</code> を返す。</p>
<dl class="user"><dt><b>戻り値: </b></dt><dd>エラーが検出された場合、msymbol_get() は <code>NULL</code> を返し、外部変数 <a class="el" href="group__m17nError.html#ga995a2e373cfd6a8e5eaca8686b5b0a73" title="m17n ライブラリのエラーコードを保持する外部変数.">merror_code</a> にエラーコードを設定する。</dd></dl>
<dl class="user"><dt><b>エラー:</b></dt><dd><code>MERROR_SYMBOL</code> </dd></dl>
<dl class="user"><dt><b>参照:</b></dt><dd><a class="el" href="group__m17nSymbol.html#ga9b90027677f183f65d85dac0d7d5bb9c" title="シンボルプロパティに値を設定する.">msymbol_put()</a> </dd></dl>

</div>
</div>
<a class="anchor" id="gaf0e0b5b8e6e0702ed87df88ad642d7f7"></a><!-- doxytag: member="symbol.c::msymbol_put_func" ref="gaf0e0b5b8e6e0702ed87df88ad642d7f7" args="(MSymbol symbol, MSymbol key, M17NFunc func)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int msymbol_put_func </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>symbol</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nCore.html#ga2216940cb054b8693aa9d65887bb4b5e">M17NFunc</a>&nbsp;</td>
          <td class="paramname"> <em>func</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>シンボルプロパティの値(関数ポインタ)を設定する. </p>
<p>関数 <a class="el" href="group__m17nSymbol.html#gaf0e0b5b8e6e0702ed87df88ad642d7f7" title="シンボルプロパティの値(関数ポインタ)を設定する.">msymbol_put_func()</a> は、関数 <a class="el" href="group__m17nSymbol.html#ga9b90027677f183f65d85dac0d7d5bb9c" title="シンボルプロパティに値を設定する.">msymbol_put()</a> と同様に、シンボル <b>symbol</b> のキーが <b>key</b> であるシンボルプロパティの値を設定する。但し その値は関数ポインタ <b>func</b> である。</p>
<dl class="user"><dt><b>参照:</b></dt><dd><a class="el" href="group__m17nSymbol.html#ga9b90027677f183f65d85dac0d7d5bb9c" title="シンボルプロパティに値を設定する.">msymbol_put()</a>, <a class="el" href="group__m17nCore.html#ga56e45d7b0345761359001fe038d121ae" title="汎関数型へのラッパ.">M17N_FUNC()</a> </dd></dl>

</div>
</div>
<a class="anchor" id="ga6446566f8f6a53e825cea16ffbf4c3bd"></a><!-- doxytag: member="symbol.c::msymbol_get_func" ref="ga6446566f8f6a53e825cea16ffbf4c3bd" args="(MSymbol symbol, MSymbol key)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nCore.html#ga2216940cb054b8693aa9d65887bb4b5e">M17NFunc</a> msymbol_get_func </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>symbol</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>key</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>シンボルプロパティの値 (関数ポインタ) を得る. </p>
<p>関数 <a class="el" href="group__m17nSymbol.html#ga6446566f8f6a53e825cea16ffbf4c3bd" title="シンボルプロパティの値 (関数ポインタ) を得る.">msymbol_get_func()</a> は、関数 <a class="el" href="group__m17nSymbol.html#ga62c1ccf5b0a9924061d3a596ae312527" title="シンボルプロパティの値を得る.">msymbol_get()</a> と同様に、シンボル <b>symbol</b> が持つシンボルプロパティのうち、キーが <b>key</b> であるものを得る。但し その値は関数ポインタをである。</p>
<dl class="user"><dt><b>参照:</b></dt><dd><a class="el" href="group__m17nSymbol.html#ga62c1ccf5b0a9924061d3a596ae312527" title="シンボルプロパティの値を得る.">msymbol_get()</a> </dd></dl>

</div>
</div>
<hr/><h2>変数</h2>
<a class="anchor" id="ga0346fc05efcccc8f11271b51c0fe3eeb"></a><!-- doxytag: member="symbol.c::Mnil" ref="ga0346fc05efcccc8f11271b51c0fe3eeb" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nSymbol.html#ga0346fc05efcccc8f11271b51c0fe3eeb">Mnil</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>"nil" を名前として持つシンボル. </p>
<p>シンボル <a class="el" href="group__m17nSymbol.html#ga0346fc05efcccc8f11271b51c0fe3eeb" title="&quot;nil&quot; を名前として持つシンボル.">Mnil</a> は <code>"nil"</code> という名前を持ち、一般に「偽」または「否定」を意味する。 "int" に変換された場合、値は 0 である。 <a class="el" href="group__m17nSymbol.html#ga0346fc05efcccc8f11271b51c0fe3eeb" title="&quot;nil&quot; を名前として持つシンボル.">Mnil</a> 自身はいかなるシンボルプロパティも持たない。 </p>

</div>
</div>
<a class="anchor" id="ga8769a573efbb023b4d77f9d03babc09f"></a><!-- doxytag: member="symbol.c::Mt" ref="ga8769a573efbb023b4d77f9d03babc09f" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nSymbol.html#ga8769a573efbb023b4d77f9d03babc09f">Mt</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>"t" を名前として持つシンボル. </p>
<p>シンボル <a class="el" href="group__m17nSymbol.html#ga8769a573efbb023b4d77f9d03babc09f" title="&quot;t&quot; を名前として持つシンボル.">Mt</a> は <code>"t"</code> という名前を持ち、一般に「真」または「肯定」を意味する。 </p>

</div>
</div>
<a class="anchor" id="ga60daf7d600a1f487862366a37c171ce5"></a><!-- doxytag: member="symbol.c::Mstring" ref="ga60daf7d600a1f487862366a37c171ce5" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nSymbol.html#ga60daf7d600a1f487862366a37c171ce5">Mstring</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>"string" を名前として持つシンボル. </p>
<p>シンボル <a class="el" href="group__m17nSymbol.html#ga60daf7d600a1f487862366a37c171ce5" title="&quot;string&quot; を名前として持つシンボル.">Mstring</a> は <code>"string"</code> という名前を持ち、関数 <a class="el" href="group__m17nCharacter.html#ga8c6dde5d282ae96c899f662e1dc17879" title="文字プロパティを定義する.">mchar_define_property()</a> などの引数として用いられる。 </p>

</div>
</div>
<a class="anchor" id="ga6592d4eb3c46fe7fb8993c252b8fedeb"></a><!-- doxytag: member="symbol.c::Msymbol" ref="ga6592d4eb3c46fe7fb8993c252b8fedeb" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nSymbol.html#ga6592d4eb3c46fe7fb8993c252b8fedeb">Msymbol</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>"symbol" を名前として持つシンボル. </p>
<p>定義済みシンボル <a class="el" href="group__m17nSymbol.html#ga6592d4eb3c46fe7fb8993c252b8fedeb" title="&quot;symbol&quot; を名前として持つシンボル.">Msymbol</a> は <code>"symbol"</code> という名前を持ち、関数 <a class="el" href="group__m17nCharacter.html#ga8c6dde5d282ae96c899f662e1dc17879" title="文字プロパティを定義する.">mchar_define_property()</a> などの引数として使われる。 </p>

</div>
</div>
</div>
<!--- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&nbsp;</span>全て</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&nbsp;</span>データ構造</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&nbsp;</span>ファイル</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&nbsp;</span>関数</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&nbsp;</span>変数</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&nbsp;</span>型定義</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&nbsp;</span>列挙型</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&nbsp;</span>列挙型の値</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&nbsp;</span>マクロ定義</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<!-- -*- coding: utf-8; -*- -->
<hr>

<ADDRESS>
<a href="http://www.m17n.org/m17n-lib-ja/index.html" target="mulewindow"><img src="parrot.png" align=bottom alt="m17n-lib Home" border=0></a>
</ADDRESS>
</body>
</HTML>

<!-- Copyright information

Copyright (C) 2001 Information-technology Promotion Agency (IPA)
Copyright (C) 2001-2011
  National Institute of Advanced Industrial Science and Technology (AIST)

This file is part of the m17n library documentation.

Permission is granted to copy, distribute and/or modify this document
under the terms of the GNU Free Documentation License, Version 1.2 or
any later version published by the Free Software Foundation; with no
Invariant Section, no Front-Cover Texts,
and no Back-Cover Texts.  A copy of the license is included in the
appendix entitled "GNU Free Documentation License".
-->
